// (C) Copyright 2012-2013 Hewlett-Packard Development Company, L.P.
define([], function() {"use strict";
    return {
        "waiting" : {
            "waitingMessage" : "Please wait for the appliance to respond.",
            "rebootingMessage" : "The CIC appliance is rebooting.<br />You will automatically be reconnected " +
                                 "after the appliance has restarted.",
            "rebootConfirmMsg" : "Are you sure you want to reboot the CIC appliance?",
            "confirmButton" : "Yes, Reboot",
            "cancelButton" : "Cancel",
            "title" : "Please wait...",
            "supportDumpConfirmMsg" : "A support dump is being created. <br /><br />The download will start automatically when it is ready."
        },
        "recovery" : {
            "message" : "This is where you will be able to recover the appliance when cluster quorum problems are encountered.",
            "title" : "Appliance Recovery"
        },
        "error" : {
            "title" : "Appliance Error",
            "appliance_error" : "The CIC appliance has encountered a serious error.",
            "kiosk_message" : "Rebooting the appliance may solve the problem. If not, you may perform a factory reset or create a support dump and contact your authorized support representative for assistance.",
            "broadcast_message" : "Rebooting the appliance may solve the problem. If not, create a support dump and contact your authorized support representative for assistance.",
            "reboot_link" : "Reboot the appliance",
            "reset_link" : "Perform a factory reset",
            "support_dump_link" : "Create a support dump",
            "reboot" : {
                "label" : "Reboot the appliance",
                "error" : {
                    "message" : "There was an error rebooting the appliance.",
                    "title" : "Reboot Failed"
                }
            }
        },
        "restore" : {
            "message" : "A restore is in progress.  " + 
                        "The appliance is in maintenance mode." +
                        "  Logins are disabled.  " + 
                        "You will automatically be connected when the system is available again.",
            "title" : "Restore",
            "restoring_files" : "Restoring files",
            "restoring_db" : "Restoring database",
            "starting_services" : "Starting services",
            "completed" : "Restore completed successfully.",
            "failed" : "Failed to restore from backup.",
            "unknown" : "Failed to retrieve restore status."
        },

       "reset" : {           
            "title" : "Reset",
            "resetConfirmMsg" : "Are you sure you want to reset the CIC appliance?",
            "confirmButton" : "Yes, Reset",
            "cancelButton" : "Cancel",
            "closeButton" : "Close",
            "maintenanceMsg" : "The appliance is in maintenance mode. Logins are disabled.<br>" +
                                "You will automatically be connected when the appliance is available again.",
            "resetSuccess": "Factory reset successfully completed.",
            "resetFailure": "Factory reset failed to complete."           
            
        },

        "restoreError" : {
            "restoreFailMsg" : "Unable to restore from backup.",
            "restoreFailDetails" : "Appliance has been reset to factory settings.  Login with original, factory-set credentials.",
            "restoreCloseButton" : "Close"
        },

        "restoreNoResetError" : {
            "restoreFailMsg" : "Unable to restore from backup.",
            "restoreFailDetails" : "Please create a new appliance virtual machine from an HP-provided template."
        },
        
        "starting" : {
            "startingMessage" : "Please wait while the appliance starts...",
            "startingProgress" : "{0}%"
        },
        
        "upgrade" : {
            "message" : "Upgrade in progress.",
            "title" : "Upgrade"
            
        },
        "unavailable" : {
            "message" : "The appliance is temporarily unavailable.",
            "title" : "Appliance Unavailable"
        },
        "useFloating" : {
            "message" : "Please use an appliance floating address ({0}) - the fixed addresses should be used for " +
                        "setup and troubleshooting only.",
            "title" : "Use Floating Address"
        },
        "supportDump" : {
            "created_message" : "Support Dump created successfully.",
            "title" : "Support Dump Available",
            "error" : {
                "message" : "There was an error in creating support dump.",
                "title" : "Support Dump Creation Failed",
                "closeButton" : "Close"
            }
        }
    };
});
